Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mpisws.p2p.transport.table
Class TableTransprotLayerImpl<Identifier,Key,Value>

    java.lang.Object
      org.mpisws.p2p.transport.table.TableTransprotLayerImpl<Identifier,Key,Value>

All Implemented Interfaces:
  TableTransportLayer<Identifier,Key,Value>, TransportLayer<Identifier,java.nio.ByteBuffer>, TransportLayerCallback<Identifier,java.nio.ByteBuffer>, Destructable

Direct Known Subclasses:
  IdentityTransportLayerImpl

    public class TableTransprotLayerImpl<Identifier,Key,Value>

extends java.lang.Object
implements TableTransportLayer<Identifier,Key,Value>, TransportLayerCallback<Identifier,java.nio.ByteBuffer>

Author:
  Jeff Hoye

Field Summary
`protected TransportLayerCallback<Identifier,java.nio.ByteBuffer>` | `callback`
`protected ErrorHandler<Identifier>` | `errorHandler`
`protected Serializer<Key>` | `keySerializer`
`protected TableStore<Key,Value>` | `knownValues` Could just be a hashTable
`protected Logger` | `logger`
`static byte` | `PASSTHROUGH`
`static byte` | `REQUEST`
`static byte` | `RESPONSE_FAILED`
`static byte` | `RESPONSE_SUCCESS`
`protected TransportLayer<Identifier,java.nio.ByteBuffer>` | `tl`
`protected Serializer<Value>` | `valueSerializer`

Constructor Summary
`TableTransprotLayerImpl(Serializer<Key> iSerializer, Serializer<Value> cSerializer, TableStore<Key,Value> tableStore, TransportLayer<Identifier,java.nio.ByteBuffer> tl, Environment env)`

Method Summary
`void` | `acceptMessages(boolean b)` Toggle accepting incoming messages.
`void` | `acceptSockets(boolean b)` Toggle accepting new sockets.
`void` | `destroy()`
`Identifier` | `getLocalIdentifier()` The local node.
`void` | `handleValueRequest(P2PSocket<Identifier> sock)`
`boolean` | `hasKey(Key i)`
`void` | `incomingSocket(P2PSocket<Identifier> sock)` Notification of a new socket.
`void` | `messageReceived(Identifier i, java.nio.ByteBuffer m, java.util.Map<java.lang.String,java.lang.Object> options)` Called when a new message is received.
`SocketRequestHandle<Identifier>` | `openSocket(Identifier i, SocketCallback<Identifier> deliverSocketToMe, java.util.Map<java.lang.String,java.lang.Object> options)` Open a socket to the Identifier
`Cancellable` | `requestValue(Identifier source, Key principal, Continuation<Value,java.lang.Exception> c, java.util.Map<java.lang.String,java.lang.Object> options)` REQUEST, int requestId, Key
`MessageRequestHandle<Identifier,java.nio.ByteBuffer>` | `sendMessage(Identifier i, java.nio.ByteBuffer m, MessageCallback<Identifier,java.nio.ByteBuffer> deliverAckToMe, java.util.Map<java.lang.String,java.lang.Object> options)` Send the message to the identifier
`void` | `setCallback(TransportLayerCallback<Identifier,java.nio.ByteBuffer> callback)` Set the callback for incoming sockets/messages
`void` | `setErrorHandler(ErrorHandler<Identifier> handler)` To be notified of problems not related to an outgoing messaage/socket.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PASSTHROUGH

    public static final byte PASSTHROUGH

See Also:
  Constant Field Values

### REQUEST

    public static final byte REQUEST

See Also:
  Constant Field Values

### RESPONSE_SUCCESS

    public static final byte RESPONSE_SUCCESS

See Also:
  Constant Field Values

### RESPONSE_FAILED

    public static final byte RESPONSE_FAILED

See Also:
  Constant Field Values

### knownValues

    protected TableStore<Key,Value> knownValues

  Could just be a hashTable

### callback

    protected TransportLayerCallback<Identifier,java.nio.ByteBuffer> callback

### tl

    protected TransportLayer<Identifier,java.nio.ByteBuffer> tl

### keySerializer

    protected Serializer<Key> keySerializer

### valueSerializer

    protected Serializer<Value> valueSerializer

### errorHandler

    protected ErrorHandler<Identifier> errorHandler

### logger

    protected Logger logger

Constructor Detail

### TableTransprotLayerImpl

    public TableTransprotLayerImpl(Serializer<Key> iSerializer,
                                   Serializer<Value> cSerializer,
                                   TableStore<Key,Value> tableStore,
                                   TransportLayer<Identifier,java.nio.ByteBuffer> tl,
                                   Environment env)

Parameters:
  `iSerializer` -
  `cSerializer` -
  `tableStore` - should be pre-populated with any persistent or initial values
  `tl` -
  `env` -

Method Detail

### requestValue

    public Cancellable requestValue(Identifier source,
                                    Key principal,
                                    Continuation<Value,java.lang.Exception> c,
                                    java.util.Map<java.lang.String,java.lang.Object> options)

  REQUEST, int requestId, Key

  Specified by:
    `requestValue` in interface `TableTransportLayer<Identifier,Key,Value>`
  Returns:
    UnknownValueException if the source doesn't value for the key

### openSocket

    public SocketRequestHandle<Identifier> openSocket(Identifier i,
                                                      SocketCallback<Identifier> deliverSocketToMe,
                                                      java.util.Map<java.lang.String,java.lang.Object> options)

  Description copied from interface: `TransportLayer`
  Open a socket to the Identifier

  Specified by:
    `openSocket` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`
  Parameters:
    `i` - who to open the socket to
    `deliverSocketToMe` - the callback when the socket is opened
    `options` - options on how to open the socket (don't source route, encrypt etc) (may not be respected if layer cannot provide service)
  Returns:
    an object to cancel opening the socket if it takes to long, or is no longer relevant

### incomingSocket

    public void incomingSocket(P2PSocket<Identifier> sock)
                        throws java.io.IOException

  Description copied from interface: `TransportLayerCallback`
  Notification of a new socket.

  Specified by:
    `incomingSocket` in interface `TransportLayerCallback<Identifier,java.nio.ByteBuffer>`
  Parameters:
    `sock` - the incoming socket
  Throws:
    `java.io.IOException`

### handleValueRequest

    public void handleValueRequest(P2PSocket<Identifier> sock)

### hasKey

    public boolean hasKey(Key i)

  Specified by:
    `hasKey` in interface `TableTransportLayer<Identifier,Key,Value>`

### acceptMessages

    public void acceptMessages(boolean b)

  Description copied from interface: `TransportLayer`
  Toggle accepting incoming messages. Useful in flow control if overwhelmed by incoming sockets. Default: true

  Specified by:
    `acceptMessages` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`

### acceptSockets

    public void acceptSockets(boolean b)

  Description copied from interface: `TransportLayer`
  Toggle accepting new sockets. Useful in flow control if overwhelmed by incoming sockets. Default: true

  Specified by:
    `acceptSockets` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`

### getLocalIdentifier

    public Identifier getLocalIdentifier()

  Description copied from interface: `TransportLayer`
  The local node.

  Specified by:
    `getLocalIdentifier` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`
  Returns:
    The local node.

### sendMessage

    public MessageRequestHandle<Identifier,java.nio.ByteBuffer> sendMessage(Identifier i,
                                                                            java.nio.ByteBuffer m,
                                                                            MessageCallback<Identifier,java.nio.ByteBuffer> deliverAckToMe,
                                                                            java.util.Map<java.lang.String,java.lang.Object> options)

  Description copied from interface: `TransportLayer`
  Send the message to the identifier

  Specified by:
    `sendMessage` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`
  Parameters:
    `i` - the destination
    `m` - the message
    `deliverAckToMe` - layer dependent notification when the message is sent (can indicate placed on the wire, point-to-point acknowledgment, or end-to-end acknowledgement)
    `options` - delivery options (don't source route, encrypt etc) (may not be respected if layer cannot provide service)
  Returns:
    ability to cancel the message if no longer relevant

### setCallback

    public void setCallback(TransportLayerCallback<Identifier,java.nio.ByteBuffer> callback)

  Description copied from interface: `TransportLayer`
  Set the callback for incoming sockets/messages

  Specified by:
    `setCallback` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`
  Parameters:
    `callback` - the callback for incoming sockets/messages

### setErrorHandler

    public void setErrorHandler(ErrorHandler<Identifier> handler)

  Description copied from interface: `TransportLayer`
  To be notified of problems not related to an outgoing messaage/socket. Or to be notified if a callback isn't provided.

  Specified by:
    `setErrorHandler` in interface `TransportLayer<Identifier,java.nio.ByteBuffer>`
  Parameters:
    `handler` - to be notified of problems not related to a specific messaage/socket.

### destroy

    public void destroy()

  Specified by:
    `destroy` in interface `Destructable`

### messageReceived

    public void messageReceived(Identifier i,
                                java.nio.ByteBuffer m,
                                java.util.Map<java.lang.String,java.lang.Object> options)
                         throws java.io.IOException

  Description copied from interface: `TransportLayerCallback`
  Called when a new message is received.

  Specified by:
    `messageReceived` in interface `TransportLayerCallback<Identifier,java.nio.ByteBuffer>`
  Parameters:
    `i` - The node it is coming from
    `m` - the message
    `options` - describe how the message arrived (udp/tcp, encrypted etc)
  Throws:
    `java.io.IOException` - if there is a problem decoding the message

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.